searchNodes=[{"doc":"Documentation for VintageNetWizard.","ref":"VintageNetWizard.html","title":"VintageNetWizard","type":"module"},{"doc":"Conditionally run the wizard if there is no configurations present This function is the same VintageNetWizard.run_wizard/1 however it will first check if there are any configurations for the interface. This is useful if you want a device to start the wizard only if there are no configurations for the interface. When there are configurations found for the interface this function returns :configured to let the consuming application know that the wizard wasn't needed. If you want more control on how to start the wizard or if you want to force start the wizard you can call VintageNetWizard.run_wizard/1 .","ref":"VintageNetWizard.html#run_if_unconfigured/1","title":"VintageNetWizard.run_if_unconfigured/1","type":"function"},{"doc":"Run the wizard. This means the WiFi module will be put into access point mode and the web server will be started. Options: :backend - Implementation for communicating with the network drivers (defaults to VintageNetWizard.Backend.Default ) :captive_portal - Whether to run in captive portal mode (defaults to true ) :device_info - A list of string tuples to render in a table in the footer (see README.md ) :ifname - The network interface to use (defaults to &quot;wlan0&quot; ) :ap_ifname - The network interface to use to run the endpoint. Defaults to the value of ifname . :inactivity_timeout - Minutes to run before automatically stopping (defaults to 10 minutes) or :infinity to disable the timeout :on_exit - {module, function, args} tuple specifying callback to perform after stopping the server. :ssl - A Keyword list of :ssl.tls_server_options . See Plug.SSL.configure/1 . :ui - a subset of UI configuration for title, title color, and button color.","ref":"VintageNetWizard.html#run_wizard/1","title":"VintageNetWizard.run_wizard/1","type":"function"},{"doc":"Stop the wizard. This will apply the current configuration in memory and completely stop the web and backend processes.","ref":"VintageNetWizard.html#stop_wizard/1","title":"VintageNetWizard.stop_wizard/1","type":"function"},{"doc":"Check if an interface has a configuration","ref":"VintageNetWizard.html#wifi_configured?/1","title":"VintageNetWizard.wifi_configured?/1","type":"function"},{"doc":"","ref":"VintageNetWizard.html#t:stop_reason/0","title":"VintageNetWizard.stop_reason/0","type":"type"},{"doc":"This module contains utilities for configuration VintageNet in AP Mode","ref":"VintageNetWizard.APMode.html","title":"VintageNetWizard.APMode","type":"module"},{"doc":"Return a configuration to put VintageNet into AP mode hostname - the device's hostname which will be modified to be the AP's SSID our_name - the name for clients to use when connecting to the wizard if not using the IP address . class_c_subnet - A class C subnet to use for all of the IP addresses on this network .","ref":"VintageNetWizard.APMode.html#ap_mode_configuration/3","title":"VintageNetWizard.APMode.ap_mode_configuration/3","type":"function"},{"doc":"Change the WIFi module to exit AP mode and apply the wifi configs.","ref":"VintageNetWizard.APMode.html#exit_ap_mode/2","title":"VintageNetWizard.APMode.exit_ap_mode/2","type":"function"},{"doc":"Change the WiFi module into access point mode","ref":"VintageNetWizard.APMode.html#into_ap_mode/1","title":"VintageNetWizard.APMode.into_ap_mode/1","type":"function"},{"doc":"Return SSID that is used for AP Mode","ref":"VintageNetWizard.APMode.html#ssid/0","title":"VintageNetWizard.APMode.ssid/0","type":"function"},{"doc":"Backends define the boundaries of getting access points, handling incoming messages, and scanning the network","ref":"VintageNetWizard.Backend.html","title":"VintageNetWizard.Backend","type":"behaviour"},{"doc":"Get all the access points that the backend knowns about","ref":"VintageNetWizard.Backend.html#c:access_points/1","title":"VintageNetWizard.Backend.access_points/1","type":"callback"},{"doc":"Apply the WiFi configurations The configurations passed are network configurations that can be passed into the :network list in a VintageNetWiFi configuration.","ref":"VintageNetWizard.Backend.html#c:apply/2","title":"VintageNetWizard.Backend.apply/2","type":"callback"},{"doc":"Perform final completion steps for the network configurations","ref":"VintageNetWizard.Backend.html#c:complete/2","title":"VintageNetWizard.Backend.complete/2","type":"callback"},{"doc":"Return the configuration status of a configuration that has been applied","ref":"VintageNetWizard.Backend.html#c:configuration_status/1","title":"VintageNetWizard.Backend.configuration_status/1","type":"callback"},{"doc":"Handle any message the is received by another process If you want the socket to send data to the client return {:reply, message, state} , otherwise return {:noreply, state}","ref":"VintageNetWizard.Backend.html#c:handle_info/2","title":"VintageNetWizard.Backend.handle_info/2","type":"callback"},{"doc":"Do any initialization work like subscribing to messages Will be passed the interface names that the backend should use to scan and to set AP mode. By default both will be &quot;wlan0&quot; . If you want to use different interface names you can pass them in as options to VintageNetWizard.run_wizard/1 .","ref":"VintageNetWizard.Backend.html#c:init/2","title":"VintageNetWizard.Backend.init/2","type":"callback"},{"doc":"Apply any actions required to set the backend back to an initial default state","ref":"VintageNetWizard.Backend.html#c:reset/1","title":"VintageNetWizard.Backend.reset/1","type":"callback"},{"doc":"Start scanning for WiFi access points","ref":"VintageNetWizard.Backend.html#c:start_scan/1","title":"VintageNetWizard.Backend.start_scan/1","type":"callback"},{"doc":"Stop the scan for WiFi access points","ref":"VintageNetWizard.Backend.html#c:stop_scan/1","title":"VintageNetWizard.Backend.stop_scan/1","type":"callback"},{"doc":"","ref":"VintageNetWizard.Backend.html#t:configuration_status/0","title":"VintageNetWizard.Backend.configuration_status/0","type":"type"},{"doc":"","ref":"VintageNetWizard.Backend.html#t:device_info_name/0","title":"VintageNetWizard.Backend.device_info_name/0","type":"type"},{"doc":"","ref":"VintageNetWizard.Backend.html#t:device_info_value/0","title":"VintageNetWizard.Backend.device_info_value/0","type":"type"},{"doc":"","ref":"VintageNetWizard.Backend.html#t:opt/0","title":"VintageNetWizard.Backend.opt/0","type":"type"},{"doc":"The default backend implementation for target devices This backend will be used if no other backend is configured in the application configuration.","ref":"VintageNetWizard.Backend.Default.html","title":"VintageNetWizard.Backend.Default","type":"module"},{"doc":"A default backend for host machines. This is useful for testing and local JavaScript development.","ref":"VintageNetWizard.Backend.Mock.html","title":"VintageNetWizard.Backend.Mock","type":"module"},{"doc":"Server for managing a VintageNet.Backend implementation","ref":"VintageNetWizard.BackendServer.html","title":"VintageNetWizard.BackendServer","type":"module"},{"doc":"List out access points","ref":"VintageNetWizard.BackendServer.html#access_points/0","title":"VintageNetWizard.BackendServer.access_points/0","type":"function"},{"doc":"Apply the configurations saved in the backend to the system.","ref":"VintageNetWizard.BackendServer.html#apply/0","title":"VintageNetWizard.BackendServer.apply/0","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"VintageNetWizard.BackendServer.html#child_spec/1","title":"VintageNetWizard.BackendServer.child_spec/1","type":"function"},{"doc":"","ref":"VintageNetWizard.BackendServer.html#child_spec/3","title":"VintageNetWizard.BackendServer.child_spec/3","type":"function"},{"doc":"","ref":"VintageNetWizard.BackendServer.html#complete/0","title":"VintageNetWizard.BackendServer.complete/0","type":"function"},{"doc":"Get the current state of the WiFi configuration","ref":"VintageNetWizard.BackendServer.html#configuration_state/0","title":"VintageNetWizard.BackendServer.configuration_state/0","type":"function"},{"doc":"Get the current configuration status","ref":"VintageNetWizard.BackendServer.html#configuration_status/0","title":"VintageNetWizard.BackendServer.configuration_status/0","type":"function"},{"doc":"Get a list of the current configurations","ref":"VintageNetWizard.BackendServer.html#configurations/0","title":"VintageNetWizard.BackendServer.configurations/0","type":"function"},{"doc":"Delete the configuration by ssid","ref":"VintageNetWizard.BackendServer.html#delete_configuration/1","title":"VintageNetWizard.BackendServer.delete_configuration/1","type":"function"},{"doc":"Return information about the device for the web page's footer","ref":"VintageNetWizard.BackendServer.html#device_info/0","title":"VintageNetWizard.BackendServer.device_info/0","type":"function"},{"doc":"Reset the backend to an initial default state.","ref":"VintageNetWizard.BackendServer.html#reset/0","title":"VintageNetWizard.BackendServer.reset/0","type":"function"},{"doc":"Save a network configuration to the backend The network configuration is a map that can be included in the :network field of a VintageNetWiFi configuration.","ref":"VintageNetWizard.BackendServer.html#save/1","title":"VintageNetWizard.BackendServer.save/1","type":"function"},{"doc":"Pass list of SSIDs ( priority_order ), sort the configurations to match that order.","ref":"VintageNetWizard.BackendServer.html#set_priority_order/1","title":"VintageNetWizard.BackendServer.set_priority_order/1","type":"function"},{"doc":"","ref":"VintageNetWizard.BackendServer.html#start_link/3","title":"VintageNetWizard.BackendServer.start_link/3","type":"function"},{"doc":"Start scanning for WiFi access points","ref":"VintageNetWizard.BackendServer.html#start_scan/0","title":"VintageNetWizard.BackendServer.start_scan/0","type":"function"},{"doc":"Stop scanning for WiFi access points","ref":"VintageNetWizard.BackendServer.html#stop_scan/0","title":"VintageNetWizard.BackendServer.stop_scan/0","type":"function"},{"doc":"Subscribe to messages from the backend","ref":"VintageNetWizard.BackendServer.html#subscribe/0","title":"VintageNetWizard.BackendServer.subscribe/0","type":"function"},{"doc":"Supervisor for the Web part of the VintageNet Wizard.","ref":"VintageNetWizard.Web.Endpoint.html","title":"VintageNetWizard.Web.Endpoint","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"VintageNetWizard.Web.Endpoint.html#child_spec/1","title":"VintageNetWizard.Web.Endpoint.child_spec/1","type":"function"},{"doc":"Start the web server If the web server is started then {:error, already_started} is returned. Only one server can be running at a time.","ref":"VintageNetWizard.Web.Endpoint.html#start_server/1","title":"VintageNetWizard.Web.Endpoint.start_server/1","type":"function"},{"doc":"Stop the web server","ref":"VintageNetWizard.Web.Endpoint.html#stop_server/1","title":"VintageNetWizard.Web.Endpoint.stop_server/1","type":"function"},{"doc":"","ref":"VintageNetWizard.Web.Endpoint.html#t:opt/0","title":"VintageNetWizard.Web.Endpoint.opt/0","type":"type"},{"doc":"UI specific configuration :title - the title of the HTML pages that will be displayed to the user. :title_color - color of the title for branding purposes :button_color - color of the buttons for branding purposes","ref":"VintageNetWizard.Web.Endpoint.html#t:ui_opt/0","title":"VintageNetWizard.Web.Endpoint.ui_opt/0","type":"type"},{"doc":"Module for working with various WiFi configurations","ref":"VintageNetWizard.WiFiConfiguration.html","title":"VintageNetWizard.WiFiConfiguration","type":"module"},{"doc":"Get the key_mgmt type from the particular WiFi Configuration","ref":"VintageNetWizard.WiFiConfiguration.html#get_key_mgmt/1","title":"VintageNetWizard.WiFiConfiguration.get_key_mgmt/1","type":"function"},{"doc":"Make a network config from a JSON request from the VintageNetWizard client","ref":"VintageNetWizard.WiFiConfiguration.html#json_to_network_config/1","title":"VintageNetWizard.WiFiConfiguration.json_to_network_config/1","type":"function"},{"doc":"Convert a key_mgmt string into a key_mgmt","ref":"VintageNetWizard.WiFiConfiguration.html#key_mgmt_from_string/1","title":"VintageNetWizard.WiFiConfiguration.key_mgmt_from_string/1","type":"function"},{"doc":"Get a human friendly name for the type of security of a WiFiConfiguration","ref":"VintageNetWizard.WiFiConfiguration.html#security_name/1","title":"VintageNetWizard.WiFiConfiguration.security_name/1","type":"function"},{"doc":"Get the expected timeout in milisecs for a particular configuration","ref":"VintageNetWizard.WiFiConfiguration.html#timeout/1","title":"VintageNetWizard.WiFiConfiguration.timeout/1","type":"function"},{"doc":"","ref":"VintageNetWizard.WiFiConfiguration.html#t:key_mgmt/0","title":"VintageNetWizard.WiFiConfiguration.key_mgmt/0","type":"type"},{"doc":"This is a WiFi configuration wizard that uses VintageNet . It is intended for use in Nerves-based devices that don't have a display for configuring WiFi. Here's the intended use: On device initialization, if WiFi hasn't been configured, configure WiFi to AP mode and start a webserver A user connects to the access point and opens a web browser. The only website they can go to in the configuration utility. The configuration utility shows a list of access points and the user can select one or more or enter information for a hidden access point The user applies the configuration and the device stops AP mode and connects to the access point. VintageNet persists WiFi configuration so the device will be able to connect after reboots and power outages. To change the configuration later, a user needs to take a device-specific action like hold down a button for 5 seconds. This library has an example project for the Raspberry Pi for use as a demo.","ref":"readme.html","title":"VintageNet WiFi Configuration Wizard","type":"extras"},{"doc":"[x] - Simple web-based configuration utility [x] - WiFi scanning while in AP mode [x] - JSON REST-based API to support smartphone app-based configuration [x] - Captive portal detection [x] - WPA PSK configuration [ ] - WPA EAP configuration [x] - Hidden AP configuration [x] - Multiple AP selection (device tries access points in order until one works) [ ] - Custom styling and branding","ref":"readme.html#features","title":"VintageNet WiFi Configuration Wizard - Features","type":"extras"},{"doc":"Not all WiFi adapters support AP mode. Here are the ones that we've used: Raspberry Pis with built-in WiFi modules (like the RPi 3, 4 and Zero W) RT5370-based USB modules Edimax EW-7612UAn V2 (See note) It is highly likely that other modules work. We have not had any luck with other Realtek RTL8192c (in the popular Edimax EW7811Un) or MediaTek MT7601u (in lots of brands). NOTE: For the Edimax EW-7612UAn V2 to work, you'll need to create a custom Nerves system with CONFIG_RTL8192CU=m in the linux-x.xx.defconfig as well as BR2_PACKAGE_LINUX_FIRMWARE=y and BR2_PACKAGE_LINUX_FIRMWARE_RTL_81XX=y in nerves_defconfig .","ref":"readme.html#supported-wifi-adapters","title":"VintageNet WiFi Configuration Wizard - Supported WiFi adapters","type":"extras"},{"doc":"It is expected that you're using VintageNet already. If you're not, see that project first. VintageNetWizard is an OTP application so it's mostly self-contained. Add it to your mix dependencies like so: { :vintage_net_wizard , &quot;~&gt; 0.4&quot; } The configuration wizard is not started by default to allow for more control over business specific situations. You will need to add a call in your code when you want the device placed into AP mode and the wizard started: defmodule MyApp do use Application def start ( _type , _args ) do if should_start_wizard? ( ) do VintageNetWizard . run_wizard end # ... Supervisor . start_link ( children , opts ) end end This will be sufficient to try it out on a device that hasn't been configured yet. You will want to add a mechanism for forcing the wizard the run WiFi configuration again, such as holding a button for 5+ seconds. Take a look at Running the example section for steps on setting up a button and running a quick example firmware on a device. UI Customization VintageNetWizard allows you to add customization to the UI. The three UI items that can be customized are: :title , :title_color , and :button_color . VintageNetWizard . run_wizard ( ui : [ title : &quot;My WiFi Wizard&quot; , title_color : &quot;red&quot; , button_color : &quot;#F0F0AD&quot; ] ) Each configuration option is optional and will fall back to VintageNetWizard s default colors and title. DNS in AP-mode When the wizard is running, users go to either http://192.168.0.1/ or http://wifi.config/ to access the web user interface. Both can be changed via the config.exs : config :vintage_net_wizard , dns_name : &quot;my-wifi-config.com&quot; , subnet : &quot;192.168.0.0&quot; Port VintageNetWizard starts a webserver on port 80 by default. If port 80 is not available on your device or you would prefer a different port, add the following to your config.exs : config :vintage_net_wizard , port : 4001 If SSL is enabled the default port is 443 . SSL To use SSL with the web UI, you can pass SSL options to VintageNetWizard.run_wizard/1 : VintageNetWizard . run_wizard ( ssl : [ keyfile : &quot;/path/to/key.pem&quot; , certfile : &quot;/path/to/cert.pem&quot; ] ) To see all available options see Plug.SSL.configure/1 and Erlang's :ssl module. Device Info If you want to display extra data about the device in the footer of the UI you can pass in a list of key-value pairs to VintageNetWizard.run_wizard/1 : VintageNetWizard . run_wizard ( device_info : [ { &quot;Serial number&quot; , &quot;1234&quot; } , { &quot;Version&quot; , &quot;0.1.0&quot; } ] ) The first item in the key-value pair is display name of the info and the second item will be the value of the item. Interface name VintageNetWizard uses &quot;wlan0&quot; by default. If you have more than one wireless LAN or the interface is called something else, pass the appropriate interface name to VintageNetWizard.run_wizard/1 to use it: VintageNetWizard . run_wizard ( ifname : &quot;wlan1&quot; ) Backends Backends control how VintageNetWizard configures the network. The default backend changes the network configuration as you would expect. This can get in the way of development and can be disabled by using the VintageNetWizard.Backend.Mock backend: config :vintage_net_wizard , backend : VintageNetWizard.Backend.Mock Captive Portal Captive portal is enabled by default. If using a port other than 80 then all traffic on port 80 will be captured and redirected to the specified wizard address in order to trigger the portal. You can disable captive portal in your configuration: config :vintage_net_wizard , captive_portal : false Inactivity Timeout After a set mount of time of inactivity the wizard will timeout and shut down the server. This prevents a device using the wizard to infinitely be in AP mode. The default timeout is 10 minutes, but can be configured: config :vintage_net_wizard , inactivity_timeout : &lt; timeout in minutes &gt; The timeout can also be explicitly disabled by supplying :infinity : config :vintage_net_wizard , inactivity_timeout : :infinity","ref":"readme.html#configuration","title":"VintageNet WiFi Configuration Wizard - Configuration","type":"extras"},{"doc":"It is possible to write a smartphone app to configure your device using an API endpoint. Documentation for the API is in json-api.md .","ref":"readme.html#json-api","title":"VintageNet WiFi Configuration Wizard - JSON API","type":"extras"},{"doc":"The example builds a Nerves firmware image for supported Nerves devices that demonstrates the wizard. The wizard will run on the first boot and also after a button has been held down for 5 seconds. For the button to work, you'll need to wire up a button to GPIO 17/pin 11 and 3v3/pin 1 on the Raspberry Pi's GPIO header. See the image below for the location: If you don't have a button, you can use a jumper wire to temporarily connect 3v3 power to pin 11. If you have a Raspberry Pi hat with a button connected to a different GPIO pin, you can specify with pin to use in your config: config :wizard_example , gpio_pin : 27 The next step is to build the firmware. Make sure that you've installed Nerves and run the following: cd example # Set the target to rpi0, rpi3, or rpi4 depending on what you have export MIX_TARGET=rpi3 mix deps.get mix firmware # Insert a MicroSD card or whatever media your board takes mix burn Place the MicroSD card in the Raspberry Pi and power it on. You should see a WiFi access point appear with the SSID &quot;nerves-1234&quot; where &quot;1234&quot; are part of the device's serial number. Connect to the access point and then point your web browser at http://wifi.config or http://192.168.0.1/ . If you've configured an SSL certificate, it's possible to use https . You may also need to change the :dns_name configuration to match the name on your SSL certificate. The SSID defaults to the hostname of the device, and you can change the SSID via the config.exs : config :vintage_net_wizard , ssid : &quot;MY_SSID&quot;","ref":"readme.html#running-the-example","title":"VintageNet WiFi Configuration Wizard - Running the example","type":"extras"},{"doc":"If your application runs a webserver or has other functionality that is incompatible with the wizard, you can use the :on_exit option to VintageNetWizard.run_wizard/1 to register a completion callback. The callback has the form, {module, function, args} . Here's an example: defmodule MyApp do def start_wizard ( ) do VintageNetWizard . run_wizard ( on_exit : { __MODULE__ , :handle_on_exit , [ ] } ) end def handle_on_exit ( ) do Logger . info ( &quot;VintageNetWizard stopped&quot; ) end end","ref":"readme.html#stop-callback","title":"VintageNet WiFi Configuration Wizard - Stop callback","type":"extras"},{"doc":"It's possible to work on the wizard locally and without using Nerves or changing the network settings of your development machine: $ mix deps.get $ iex -S mix iex&gt; VintageNetWizard.run_wizard 07:49:00.710 [info] Go to http://localhost:4001/ :ok Look in lib/vintage_net_wizard/backend/mock.ex if you need to change anything for your testing.","ref":"readme.html#development","title":"VintageNet WiFi Configuration Wizard - Development","type":"extras"},{"doc":"","ref":"json-api.html","title":"JSON API","type":"extras"},{"doc":"Get Access Points Configure SSID Priority Configure an SSID Delete an SSID configuration Get Configurations Get Configuration Status Apply Complete the Configuration Process Get access points This request returns a list of known access points and their properties. Hidden access points are not returned. Path: /api/v1/access_points Method: GET Response: Array AccessPoint Response Code: 200 Response [ { &quot;ssid&quot;: &quot;Free WiFi!&quot;, &quot;frequency&quot;: 2437, &quot;band&quot;: &quot;wifi_2_4_ghz&quot;, &quot;channel&quot;: 6, &quot;flags&quot;: [&quot;ess&quot;], &quot;signal_percent&quot;: 100, }, { &quot;ssid&quot;: &quot;Imperial Star Destroyer&quot;, &quot;frequency&quot;: 5755, &quot;band&quot;: &quot;wifi_5_ghz&quot;, &quot;channel&quot;: 151, &quot;flags&quot;: [&quot;wpa2_psk_ccmp&quot;, &quot;ess&quot;], &quot;signal_percent&quot;: 75 } ] Configure SSID priority This endpoint takes a list of SSIDs. Each SSID is tried in order until a successful connection is made. It is not required to list all configured SSIDs. Path: /api/v1/ssids Method: PUT Request: Array String Response: Empty Response Code: 204 Example Request [ &quot;Millennium Falcon&quot;, &quot;Death Star&quot;, &quot;TIE-fighter-01&quot;, &quot;lukes-lightsaber&quot; ] Configure an SSID Set connection parameters for an SSID . Path: /api/v1/&lt;ssid&gt;/configuration Method: PUT Request: WiFiConfiguration Response: Empty Response Code: 204 Example Request /api/v1/millennium-falcon/configuration { &quot;key_mgmt&quot;: &quot;wpa_psk&quot;, &quot;password&quot;: &quot;Chewbacca&quot; } Errors If the configuration is passed is invalid the endpoint will return with a 400 status with one of the below errors: { &quot;error&quot;: &quot;password_required&quot;, &quot;message&quot;: &quot;A password is required for wpa_psk access points.&quot; } If the configuration is provide a key_mgmt field and there is no provided password. { &quot;error&quot;: &quot;password_too_short&quot;, &quot;message&quot;: &quot;The minimum length for a password is 8.&quot; } If the password is less than 8 characters long as outlined in the IEEE Std 802.11i-2004 specification. { &quot;error&quot;: &quot;invalid_characters&quot;, &quot;message&quot;: &quot;The password provided has invalid characters.&quot; } If the password contains characters that are not valid ASCII. { &quot;error&quot;: &quot;password_too_long&quot;, &quot;message&quot;: &quot;The maximum length for a password is 63.&quot; } If the password is greater than 63 characters long as outlined in the IEEE Std 802.11i-2004 specification. Delete an SSID configuration Delete the configuration attached to an SSID Path: /api/v1/&lt;ssid&gt;/configuration Method: DELETE Request: Empty Response: Empty Response Code: 200 Get configurations Get the current known configurations. Path: /api/v1/configurations Method: GET Request: Empty Response: Array WiFiConfiguration - Passwords are filtered Response Code: 200 Request [ { &quot;ssid&quot;: &quot;Millennium Falcon&quot;, &quot;key_mgmt&quot;: &quot;wpa_psk&quot; } ] Get configuration status Get the current status of the configuration. This is useful after using the /api/v1/apply endpoint to figure out if the configurations that were provided work or not. Path: /api/v1/configuration/status Method: GET Request: Empty Response: ConfigurationStatus Response Code: 200 Apply A POST to this endpoint applies the configuration and attempts to connect to the configured WiFi networks. This will return back to AP mode and you can use the /api/v1/configuration/status endpoint to get whether or not the configuration worked or not. Path: /api/v1/apply Method: POST Request: Empty Response: Empty Response Code: 202 Complete the configuration process Finalize the configuration process. This will apply the configuration and not return to AP mode. Path: /api/v1/complete Method: GET Request: Empty Response: Empty Response Code: 202","ref":"json-api.html#endpoints","title":"JSON API - Endpoints","type":"extras"},{"doc":"AccessPoint { &quot;ssid&quot;: String, &quot;signal_percent&quot;: 0..100, &quot;frequency&quot;: Integer, &quot;band&quot;: Band, &quot;channel&quot;: Integer, &quot;flags&quot;: Flags } Band This is the WiFi radio band that the access point is using. &quot;wifi_2_4_ghz&quot; &quot;wifi_5_ghz&quot; &quot;unknown&quot; Flags Flags are reported by access points. They can be used to know whether a password is required to join the network. Example flags are &quot;wpa2&quot; , &quot;psk&quot; , and &quot;eap&quot; . Flags are documented in the vintage_net_wifi documentation KeyManagement Key management is an interpretation of the Flags that determines what information that the user needs to provide to connect to the access point. For hidden access points where the Flags are unavailable, the user will need to pick one of these. &quot;none&quot; - No security &quot;wpa_psk&quot; - WPA or WPA2 with a pre-shared key &quot;wpa_eap&quot; - WPA or WPA2 with a username and password WiFiConfiguration This specifies how to connect to one WiFi access point. The ssid and key_mgmt fields are required. Depending on the key_mgmt , password may be needed. { &quot;ssid&quot;: String, &quot;key_mgmt&quot;: KeyManagement, &quot;password&quot;: Optional String } ConfigurationStatus not_configured - No configuration attempts have taken place good - A configuration was applied and is working bad - A configuration was applied and is not working","ref":"json-api.html#types","title":"JSON API - Types","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Changed Support changing the IP subnet used by the wizard. This lets you set it to something less likely to be seen than 192.168.0.0/24. See PR #318.","ref":"changelog.html#v0-4-13-2023-05-15","title":"Changelog - v0.4.13 - 2023-05-15","type":"extras"},{"doc":"Changed Update to allow :vintage_net v0.13.0","ref":"changelog.html#v0-4-12-2023-01-20","title":"Changelog - v0.4.12 - 2023-01-20","type":"extras"},{"doc":"Changed Fixed issue preventing hidden WiFi access points from working. (@jfcloutier)","ref":"changelog.html#v0-4-11-2023-01-11","title":"Changelog - v0.4.11 - 2023-01-11","type":"extras"},{"doc":"Changed Support WiFi modules that expose two WiFi interfaces - one intended for station mode and one intended for AP mode. This allows network connectivity to be checked while using the wizard. (@jfcloutier)","ref":"changelog.html#v0-4-10-2022-07-28","title":"Changelog - v0.4.10 - 2022-07-28","type":"extras"},{"doc":"Changed Update to allow :vintage_net v0.12.0","ref":"changelog.html#v0-4-9-2022-05-04","title":"Changelog - v0.4.9 - 2022-05-04","type":"extras"},{"doc":"Added Pass :infinity to the :inactivity_timeout option to keep the wizard running indefinitely regardless of user activity (@ConnorRigby) Fixed Avoid overwriting connection details on shutdown (@paulanthonywilson) Issue when connecting to WPA2/3 networks due to deciding authentication needs based on the composite set flags supplied by the wpa_supplicant","ref":"changelog.html#v0-4-8-2022-04-29","title":"Changelog - v0.4.8 - 2022-04-29","type":"extras"},{"doc":"Fixed VintageNetWizard.Backend.Default reset callback implementation (@jeanparpaillon)","ref":"changelog.html#v0-4-7-2022-03-23","title":"Changelog - v0.4.7 - 2022-03-23","type":"extras"},{"doc":"Changed Support :phoenix_html ~&gt; 2.13 or ~&gt; 3.0 . The v0.4.5 release removed support for ~&gt; 2.13 , but it turns out that not everyone has updated and vintage_net_wizard works with both.","ref":"changelog.html#v0-4-6-2021-08-20","title":"Changelog - v0.4.6 - 2021-08-20","type":"extras"},{"doc":"Added Support for WPA3/WPA2 transitional networks. The connection still uses WPA2 even if WPA3 is supported by the WiFi module.","ref":"changelog.html#v0-4-5-2021-08-20","title":"Changelog - v0.4.5 - 2021-08-20","type":"extras"},{"doc":"Fixes Fixed an issue that prevented the wizard from timing out due to inactivity. See PR #217.","ref":"changelog.html#v0-4-4","title":"Changelog - v0.4.4","type":"extras"},{"doc":"Enhancements Improve mobile experience. Thanks to Ole Michaelis for this update.","ref":"changelog.html#v0-4-3","title":"Changelog - v0.4.3","type":"extras"},{"doc":"Bug Fixes Fix a runtime error on the apply page. Fix &quot;undefined&quot; as the wizard name during application of configuration in the dynamic content.","ref":"changelog.html#v0-4-2","title":"Changelog - v0.4.2","type":"extras"},{"doc":"Enhancements Can add some custom branding to the UI such as page title, title color, and button color. Will display pre-existing configurations on the configuration page. Update example app to use nerves_pack and updated nerves systems. Bug Fixes Fix a bug where starting VintageNetWizard would delete any pre-existing configurations.","ref":"changelog.html#v0-4-1","title":"Changelog - v0.4.1","type":"extras"},{"doc":"This release has several changes to UI text to reduce jargon and make some elements configurable. In particular, the title and footer are now configurable. Given the breadth of styling and UI updates that have been proposed, it is likely for the configuration mechanism to change again. New features The title for the UI was changed from &quot;VintageNetWizard&quot; to &quot;WiFi Setup Wizard&quot;. The footer is now empty by default. See WizardExample.Button for how to replicate the previous information in your project. An idle timer will now exit the wizard on inactivity. The default inactivity timeout is 10 minutes. This prevents accidental button presses, etc. from entering the wizard and remaining there forever.","ref":"changelog.html#v0-4-0","title":"Changelog - v0.4.0","type":"extras"},{"doc":"This release has modifications to support vintage_net v0.9.1 . It contains no functional changes.","ref":"changelog.html#v0-3-0","title":"Changelog - v0.3.0","type":"extras"},{"doc":"This release is mostly documentation updates and code refactoring without any core usage changes. It also updates dependencies, including vintage_net_wifi to allow vintage_net v0.8 if desired.","ref":"changelog.html#v0-2-4","title":"Changelog - v0.2.4","type":"extras"},{"doc":"Enhancements Support disabling captive portal","ref":"changelog.html#v0-2-3","title":"Changelog - v0.2.3","type":"extras"},{"doc":"New Features Support captive portal detection (thanks to @jmerriweather!) Bug Fixes Fix adding a network not shown in the AP list Enhancements Include the configuration status on the webpage Allow submitting the configuration without verifying it. (Useful when you want to configure networks that aren't nearby or confident the config is good) Better message page when configuration verification is running Better message when configuration fails Show WPA Enterprise option when adding a network not in the AP list","ref":"changelog.html#v0-2-2","title":"Changelog - v0.2.2","type":"extras"},{"doc":"Some fun doc updates and type fixes. Enhancements Don't require internet connectivity to consider a WiFi config as successful","ref":"changelog.html#v0-2-1","title":"Changelog - v0.2.1","type":"extras"},{"doc":"This release contains updates to use vintage_net v0.7.0 . This includes depending on vintage_net_wifi and renaming keys used for the configuration. Projects pulling this update should review the vintage_net release notes . New features Support customization of the SSID. In your config.exs , add the following: config :vintage_net_wizard , ssid : &quot;MY_SSID&quot;","ref":"changelog.html#v0-2-0","title":"Changelog - v0.2.0","type":"extras"},{"doc":"New features Added VintageNetWizard.stop_wizard/0 Added a callback so that users could be notified when configuration completes","ref":"changelog.html#v0-1-7","title":"Changelog - v0.1.7","type":"extras"},{"doc":"New features Added support for configuring WPA-EAP PEAP Bug fixes Fixed issue where the UI would ask for a password for some access points that didn't have security.","ref":"changelog.html#v0-1-6","title":"Changelog - v0.1.6","type":"extras"},{"doc":"Bug fixes Fixed error when not using SSL Don't create invalid SSIDs if the hostname isn't set or is something really long","ref":"changelog.html#v0-1-5","title":"Changelog - v0.1.5","type":"extras"},{"doc":"Improvements Better handle using Erlang :ssl options when starting the wizard","ref":"changelog.html#v0-1-4","title":"Changelog - v0.1.4","type":"extras"},{"doc":"Improvements Add dnsd to reduce connection time and allow users to connect via DNS names (mDNS was also possible, but not as likely to work everywhere)","ref":"changelog.html#v0-1-3","title":"Changelog - v0.1.3","type":"extras"},{"doc":"Improvements Actively update WiFi networks in the UI Validate WPA passphrases Bug fixes AP mode configuration is no longer persisted. If a device is rebooted when running the wizard, it will start with the previous configuration. Fix SSL certificate paths","ref":"changelog.html#v0-1-2","title":"Changelog - v0.1.2","type":"extras"},{"doc":"Improvements Developer must now explicitly start the wizard server to place device into AP mode. This prevents the device from starting up automatically in and unwanted state.","ref":"changelog.html#v0-1-1","title":"Changelog - v0.1.1","type":"extras"},{"doc":"Initial release","ref":"changelog.html#v0-1-0","title":"Changelog - v0.1.0","type":"extras"}]